## gr1c-0.13.3.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
# SCL; 2 Dec 2013.

project (gr1c)
set (CUDD_ROOT extern/cudd-2.5.0)
add_definitions (-DHAVE_IEEE_754 -DSIZEOF_VOID_P=8 -DSIZEOF_LONG=8)
set (USE_READLINE 0)

include_directories (${CUDD_ROOT}/include)
find_package (BISON)
find_package (FLEX)

bison_target (SpecParser gr1c_parse.y ${CMAKE_CURRENT_BINARY_DIR}/y.tab.c COMPILE_FLAGS "-y -d")
flex_target (SpecScanner gr1c_scan.l ${CMAKE_CURRENT_BINARY_DIR}/gr1c_scan.c)
add_flex_bison_dependency (SpecScanner SpecParser)

include_directories (${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
add_executable (gr1c main.c interactive.c solve_operators.c solve.c ptree.c automaton.c ${BISON_SpecParser_OUTPUTS} ${FLEX_SpecScanner_OUTPUTS})
install (TARGETS gr1c RUNTIME DESTINATION bin)

find_library (cudd libcudd.a PATHS ${CMAKE_CURRENT_SOURCE_DIR}/${CUDD_ROOT}/cudd NO_DEFAULT_PATH)
find_library (mtr libmtr.a PATHS ${CMAKE_CURRENT_SOURCE_DIR}/${CUDD_ROOT}/mtr NO_DEFAULT_PATH)
find_library (st libst.a PATHS ${CMAKE_CURRENT_SOURCE_DIR}/${CUDD_ROOT}/st NO_DEFAULT_PATH)
find_library (util libutil.a PATHS ${CMAKE_CURRENT_SOURCE_DIR}/${CUDD_ROOT}/util NO_DEFAULT_PATH)
find_library (epd libepd.a PATHS ${CMAKE_CURRENT_SOURCE_DIR}/${CUDD_ROOT}/epd NO_DEFAULT_PATH)
target_link_libraries (gr1c ${cudd} ${mtr} ${st} ${util} ${epd} m)

if (${USE_READLINE})
  message (STATUS "Using GNU Readline")
  add_definitions (-DUSE_READLINE)
  find_library (readline readline)
  target_link_libraries (gr1c ${readline})
else (${USE_READLINE})
  message (STATUS "Not using GNU Readline")
endif (${USE_READLINE})

=== Makefile ===
# Build executables and documentation; run tests.
#
# SCL; 2012-2015.

RELEASE=1
COVERAGE=0

CORE_PROGRAMS = gr1c gr1c-rg
EXP_PROGRAMS = gr1c-patch
AUX_PROGRAMS = gr1c-autman


prefix = /usr/local
exec_prefix = $(prefix)
bindir = $(exec_prefix)/bin
deps_prefix = extern

# Possibly change to `cp' when `install' is unavailable
INSTALL = install

INCLUDEDIR = include
SRCDIR = src
EXPDIR = exp

LEX = flex -X
LFLAGS = 
YACC = bison -y
YFLAGS = --define=parse.error=verbose -d

CC = gcc
LD = ld -r

CFLAGS = -Wall -pedantic -std=c99 -I$(deps_prefix)/include -I$(INCLUDEDIR)

LDFLAGS = -L$(deps_prefix)/lib -lm -lcudd

# To use and statically link with GNU Readline
#CFLAGS += -DUSE_READLINE
#LDFLAGS += -lreadline

# N.B., scripted interaction tests, which are invoked if you run "make check",
# will fail if you build gr1c with GNU Readline.


ifeq ($(RELEASE),0)
	GR1C_GITHASH := $(shell git describe --dirty)
	ifdef GR1C_GITHASH
		GR1C_GITHASH := "+$(GR1C_GITHASH)"
	else
		GR1C_GITHASH := ""
	endif
	CFLAGS += -g -DGR1C_DEVEL=\".dev0$(GR1C_GITHASH)\"
else
	CFLAGS += -O3
endif

ifneq ($(COVERAGE),0)
	CFLAGS += -fprofile-arcs -ftest-coverage
	LDFLAGS += -lgcov
endif


core: $(CORE_PROGRAMS) $(EXP_PROGRAMS) $(AUX_PROGRAMS)
all: core

gr1c: main.o util.o logging.o interactive.o solve_support.o solve_operators.o solve.o ptree.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

gr1c-rg: rg_main.o util.o patching_support.o logging.o solve_support.o solve_operators.o solve.o ptree.o automaton.o automaton_io.o rg_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

gr1c-autman: util.o logging.o solve_support.o ptree.o autman.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

gr1c-patch: grpatch.o util.o logging.o interactive.o solve_metric.o solve_support.o solve_operators.o solve.o patching.o patching_support.o patching_hotswap.o ptree.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

grjit: grjit.o sim.o util.o logging.o interactive.o solve_metric.o solve_support.o solve_operators.o solve.o ptree.o automaton.o automaton_io.o gr1c_parse.o
	$(CC) -o $@ $^ $(LDFLAGS)

autman.o: aux/autman.c
	$(CC) $(CFLAGS) -c $^

grpatch.o: $(EXPDIR)/grpatch.c
	$(CC) $(CFLAGS) -c $^
grjit.o: $(EXPDIR)/grjit.c
	$(CC) $(CFLAGS) -c $^

main.o: $(SRCDIR)/main.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
rg_main.o: $(SRCDIR)/rg_main.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
sim.o: $(SRCDIR)/sim.c
	$(CC) $(CFLAGS) -c $^
util.o: $(SRCDIR)/util.c
	$(CC) $(CFLAGS) -c $^
ptree.o: $(SRCDIR)/ptree.c
	$(CC) $(CFLAGS) -c $^
logging.o: $(SRCDIR)/logging.c
	$(CC) $(CFLAGS) -c $^
automaton.o: $(SRCDIR)/automaton.c
	$(CC) $(CFLAGS) -c $^
automaton_io.o: $(SRCDIR)/automaton_io.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
interactive.o: $(SRCDIR)/interactive.c $(INCLUDEDIR)/common.h
	$(CC) $(CFLAGS) -c $<
solve_metric.o: $(SRCDIR)/solve_metric.c
	$(CC) $(CFLAGS) -c $^
solve_support.o: $(SRCDIR)/solve_support.c
	$(CC) $(CFLAGS) -c $^
solve_operators.o: $(SRCDIR)/solve_operators.c
	$(CC) $(CFLAGS) -c $^
solve.o: $(SRCDIR)/solve.c
	$(CC) $(CFLAGS) -c $^
patching.o: $(SRCDIR)/patching.c
	$(CC) $(CFLAGS) -c $^
patching_support.o: $(SRCDIR)/patching_support.c
	$(CC) $(CFLAGS) -c $^
patching_hotswap.o: $(SRCDIR)/patching_hotswap.c
	$(CC) $(CFLAGS) -c $^

gr1c_parse.o: $(SRCDIR)/gr1c_scan.l $(SRCDIR)/gr1c_parse.y
	$(YACC) $(YFLAGS) $(SRCDIR)/gr1c_parse.y
	$(LEX) $<
	$(CC) $(CFLAGS) -c lex.yy.c y.tab.c
	$(LD) lex.yy.o y.tab.o -o $@
rg_parse.o: $(SRCDIR)/gr1c_scan.l $(SRCDIR)/rg_parse.y gr1c_parse.o
	$(YACC) $(YFLAGS) $(SRCDIR)/rg_parse.y
	$(LEX) $<
	$(CC) $(CFLAGS) -c lex.yy.c y.tab.c
	$(LD) lex.yy.o y.tab.o -o $@

install:
	$(INSTALL) $(CORE_PROGRAMS) $(EXP_PROGRAMS) $(AUX_PROGRAMS) $(DESTDIR)$(bindir)

uninstall:
	rm -f $(DESTDIR)$(bindir)/gr1c $(DESTDIR)$(bindir)/gr1c-rg $(DESTDIR)$(bindir)/gr1c-patch

check: $(CORE_PROGRAMS) $(EXP_PROGRAMS)
	$(MAKE) -C tests CC="$(CC)"

.PHONY: doc
doc:
	@(cd doc; doxygen; cd ..)

# Delete built documentation
.PHONY: dclean
dclean:
	-rm -fr doc/build/*

# Delete only executables and corresponding object code
.PHONY: eclean
eclean:
	-rm -f *~ *.o y.tab.h y.tab.c lex.yy.c $(CORE_PROGRAMS) $(EXP_PROGRAMS) $(AUX_PROGRAMS)
	-rm -f *.gcno *.gcda *.gcov

# Delete testing-related things
.PHONY: tclean
tclean:
	$(MAKE) -C tests clean

# Clean everything
clean: dclean eclean tclean

=== tests/Makefile ===
# Unit and integration tests of gr1c
#
# SCL; 2012, 2013.

deps_prefix = ../extern
INCLUDEDIR = include

CFLAGS = -g -Wall -pedantic -std=c99 -I$(deps_prefix)/include -I../$(INCLUDEDIR)
LDFLAGS = -L$(deps_prefix)/lib -lm -lcudd

ifneq ($(COVERAGE),0)
	CFLAGS += -fprofile-arcs -ftest-coverage
endif

PROGRAMS = test_util test_logging test_automaton test_aut_prune_deadends test_aut_aut_load test_aut_aut_dump test_ptree test_ptree_to_BDD test_bitblasting test_solve_support test_patching

all: $(PROGRAMS)
	./test_logging
	./test_ptree
	./test_ptree_to_BDD
	./test_bitblasting
	./test_automaton
	./test_aut_prune_deadends
	./test_aut_aut_load
	./test_aut_aut_dump
	./test_solve_support
	./test_patching
	./test_util
	sh test-gr1c.sh
	sh test-grpatch.sh
	sh test-cli.sh
	sh test-verification.sh
	@echo "============================================================\nPASSED\n"


COMMON_BINS = ../util.o ../automaton.o ../automaton_io.o ../ptree.o ../solve_support.o ../logging.o

test_util: test_util.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_logging: test_logging.c
	$(CC) $(CFLAGS) $^ ../logging.o -o $@ $(LDFLAGS)

test_ptree: test_ptree.c
	$(CC) $(CFLAGS) $^ ../ptree.o -o $@ $(LDFLAGS)

test_ptree_to_BDD: test_ptree_to_BDD.c
	$(CC) $(CFLAGS) $^ ../ptree.o -o $@ $(LDFLAGS)

test_bitblasting: test_bitblasting.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_automaton: test_automaton.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_aut_prune_deadends: test_aut_prune_deadends.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_aut_aut_load: test_aut_aut_load.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_aut_aut_dump: test_aut_aut_dump.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_solve_support: test_solve_support.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) -o $@ $(LDFLAGS)

test_patching: test_patching.c
	$(CC) $(CFLAGS) $^ $(COMMON_BINS) ../patching.o ../patching_support.o -o $@ $(LDFLAGS)

clean:
	-rm -f *~ *.o $(PROGRAMS) temp_*_dump* dump*
	-rm -fr *.dSYM
	-rm -f *.gcno *.gcda *.gcov
	-rm -f pan* *.aut *.aut.pml *.aut.pml.trail
	-rm -f tmp.*

=== examples/api/Makefile ===
# Build executables and documentation; run tests.
#
# SCL; 2017.

deps_prefix = ../../extern
gr1c_include = ../../src

LEX = flex -X
LFLAGS =
YACC = bison -y
YFLAGS = -d

CC = gcc
LD = ld -r

CFLAGS = -g -Wall -pedantic -std=c99 -I$(deps_prefix)/include -I$(gr1c_include)
LDFLAGS = -L$(deps_prefix)/lib -lm -lcudd


printwin: printwin.c solve.o util.o logging.o ptree.o solve_operators.o solve_support.o automaton.o gr1c_parse.o
	$(CC) $(CFLAGS) -o $@ $^ $(LDFLAGS)


solve.o: $(gr1c_include)/solve.c
	$(CC) $(CFLAGS) -c $^
util.o: $(gr1c_include)/util.c
	$(CC) $(CFLAGS) -c $^
logging.o: $(gr1c_include)/logging.c
	$(CC) $(CFLAGS) -c $^
ptree.o: $(gr1c_include)/ptree.c
	$(CC) $(CFLAGS) -c $^
solve_operators.o: $(gr1c_include)/solve_operators.c
	$(CC) $(CFLAGS) -c $^
solve_support.o: $(gr1c_include)/solve_support.c
	$(CC) $(CFLAGS) -c $^
automaton.o: $(gr1c_include)/automaton.c
	$(CC) $(CFLAGS) -c $^
gr1c_parse.o: $(gr1c_include)/gr1c_scan.l $(gr1c_include)/gr1c_parse.y
	$(YACC) $(YFLAGS) $(gr1c_include)/gr1c_parse.y
	$(LEX) $<
	$(CC) $(CFLAGS) -c lex.yy.c y.tab.c
	$(LD) lex.yy.o y.tab.o -o $@

clean:
	-rm -f *~ *.o y.tab.h y.tab.c lex.yy.c

=== packaging/macports/Portfile ===
# -*- coding: utf-8; mode: tcl; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- vim:fenc=utf-8:ft=tcl:et:sw=4:ts=4:sts=4

PortSystem          1.0
PortGroup           github 1.0

github.setup        tulip-control gr1c 0.13.2 v

categories          math devel
platforms           darwin
maintainers         {cds.caltech.edu:slivingston @slivingston} \
                    openmaintainer
license             BSD

description         Tools for GR(1) synthesis and related activities

long_description    A collection of tools for GR(1) synthesis and related \
                    activities.  Its core functionality is checking \
                    realizability of and synthesizing strategies for GR(1) \
                    specifications, though it does much more.

homepage            http://scottman.net/2012/gr1c

checksums           rmd160  b5d45b6eccb6bd70b4e3d067b6e862488c97def0 \
                    sha256  48e43eb5790a32b59cb0f3528eedb1d40072730e6046541ff593e812ad26f506 \
                    size    191959

depends_build       port:bison \
                    port:flex

depends_lib         port:libcudd

configure.cmd       true

build.args          prefix="${prefix}"

foreach arch ${configure.universal_archs} {
    lappend merger_build_args(${arch}) \
                    CC='${configure.cc} -arch ${arch}' \
                    LD='ld -r -arch ${arch}'
}

if {(!${universal_possible} || ![variant_isset universal]) && [info exists merger_build_args(${build_arch})]} {
    build.args-append $merger_build_args(${build_arch})
}

test.run            yes
test.target         check
test.args           {*}${build.args}

destroot.target     install
destroot.args       {*}${build.args}
